#include <bits/stdc++.h>
using namespace std;
int main()
{
	string p= "a";
	int n;
	cin>>n;
	int Oi,Ai,Bi,ABi;
	cin>>Oi>>Ai>>Bi>>ABi;
	int Oii=Oi,Aii=Ai,Bii=Bi,ABii=ABi;
	int SO=0,SA=0,SB=0,SAB=0;
	string s[10000];
	int BrojPotrebnihJedinica[10000];
	for(int i=0;i<n;i++)
	{

		cin>>s[i]>>BrojPotrebnihJedinica[i];
		if(s[i]=="O") SO+=BrojPotrebnihJedinica[i];
		if(s[i]=="A") SA+=BrojPotrebnihJedinica[i];
		if(s[i]=="B") SB+=BrojPotrebnihJedinica[i];
		if(s[i]=="AB") SAB+=BrojPotrebnihJedinica[i];
	}
	if(SO+SA+SB+SAB>Oi+Ai+Bi+ABi) p="nemoguce";
	else
	{
		if(SO>Oi) p="nemoguce";
		else
		{
			Oi-=SO;
			if(Oi<SA-Ai) p="nemoguce";
			else
			{
				Oi=Oi-(max((SA-Ai),0));
				if(Oi<SB-Bi) p="nemoguce";
				else
				{
					Oi=Oi-(max((SB-Bi),0));
				}
			}	
		}
	}
	int j[10000],k[10000],l[10000],m[10000];
	if(p=="nemoguce") cout<<p;
	else
	{
		for(int i=0;i<n;i++)
		{
			if(s[i]=="O")
			{	
				j[i]=BrojPotrebnihJedinica[i];
				k[i]=0;
				l[i]=0;
				m[i]=0;
				Oii-=BrojPotrebnihJedinica[i];
			}
			if(s[i]=="A")
			{
				k[i]=min(BrojPotrebnihJedinica[i],Aii);
				Aii-=k[i];
				j[i]=BrojPotrebnihJedinica[i]-k[i];
				Oii-=j[i];
				l[i]=0;
				m[i]=0;
			}
			if(s[i]=="B")
			{
				l[i]=min(BrojPotrebnihJedinica[i],Bii);
				Bii-=l[i];
				j[i]=BrojPotrebnihJedinica[i]-l[i];
				Oii-=j[i];
				k[i]=0;
				m[i]=0;
			}
		}
		
	}
	if(p!="nemoguce")
	{
		cout<<"moguce"<<endl;
		for(int i=0;i<n;i++)
		{
			if(s[i]!="AB") cout<<j[i]<<" "<<k[i]<<" "<<l[i]<<" "<<m[i]<<endl;
			else
			{
				j[i]=min(BrojPotrebnihJedinica[i],Oii);
				BrojPotrebnihJedinica[i]-=j[i];
				k[i]=min(BrojPotrebnihJedinica[i],Aii);
				BrojPotrebnihJedinica[i]-=k[i];
				l[i]=min(BrojPotrebnihJedinica[i],Bii);
				BrojPotrebnihJedinica[i]-=l[i];
				m[i]=BrojPotrebnihJedinica[i];
				cout<<j[i]<<" "<<k[i]<<" "<<l[i]<<" "<<m[i]<<endl;
			}
		}
	}
	
}